      SUBROUTINE BEGIN(L)
            include      'type.inc'
            include      'dimen.inc'
            include      'vecs.inc'
            include      'init.inc'
            include      'miscel.inc'
            include      'draw.inc'
 
      INTEGER  L,I,K,IDIAPHR
      REAL*8   DXX,XDIAPHR,VOLA,VOLB,Xmean
      EQUIVALENCE (I,K)
C***********************************************************************
C  SOD SHOCK TUBE PROBLEM
C***********************************************************************
      DXX=(Xmax-Xmin)/(L-2)
      XDIAPHR=(Xmin+Xmax)/2.d0
      IDIAPHR=L/2+1

      DO I=2,L
         X(I)=Xmin+(I-2)*DXX
      END DO

      CALL   DUCVAL  (L)

      PRINT*,'BEGIN.  L,DXX=',L,DXX
      PRINT*,'BEGIN.  Xmin,XDIAPHR,Xmax=',Xmin,XDIAPHR,Xmax
      PRINT*,'  IDIAPHR=',IDIAPHR
      IF(ABS((X(IDIAPHR)-XDIAPHR)/(Xmax-Xmin)).GT.1.d-7) GOTO 7001

      DO K=1,L
               I  = K
          UG  (I) = 0
         DUGDT(I) = 0
          DUDT(I) = 0
         DRODT(I) = 0
           DRO(K) = 0
            DU(K) = 0
            Ux(K) = 0
           ROx(K) = 0
         DUDTx(K) = 0
        DRODTx(K) = 0
      END DO

      
      DO 1002 K=2,LL
!     print *, 'K,Z(K)=' ,K,Z(K)
      IF (I.LT.IDIAPHR) THEN    !  LEFT STATE
           U(K) =   ULI
          RO(K) =  ROLI - Z(K)  ! Flat water surface
          RO(K) =  ROLI
         ROU(K) =  RO(K)*ULI
         MAT(K) = MATLI
      ELSE                      !  RIGHT STATE
           U(K) =   URI
          RO(K) =  RORI - Z(K)  ! Flat water surface
          RO(K) =  RORI
         ROU(K) =  RO(K)*URI
         MAT(K) = MATRI
      END IF
 1002 CONTINUE

      X(1)=Xmin
      X(L)=Xmax
      Xmin=X(2)
      Xmax=X(L)
      MAT(1)=MAT(2)
      MAT(L)=MAT(LL)

C  MESH SPACING  DX(K)
      DO K=2,LL
         I     = K
         DX(K) = X(I+1)-X(I)
      END DO

      CALL   BOUNDARY(L)

C***********************************************************************

      PRINT*,'END BEGIN'
      RETURN
C***********************************************************************
C************* ERROR MESSAGES ******************************************
C***********************************************************************
 7001 CONTINUE
      PRINT 7101,(XDIAPHR-X(IDIAPHR))/(Xmax-Xmin)
 7101 FORMAT(/'FROM BEGIN.  DIAPHRAGM SHOULD COINCIDE WITH SOME'/
     1        'GRID POINT.  (XDIAPHR-X(IDIAPHR))/(Xmax-Xmin)=',E13.4/)
      CALL ENDRUN(7001)
      END




