      SUBROUTINE INIDAT(L)

                include  'type.inc'
                include  'dimen.inc'
                include  'init.inc'
                include  'miscel.inc'
                include  'draw.inc'

      INTEGER  L,N
      CHARACTER*80 Comment
      NAMELIST /IN/Comment,Problem,TITLEA,TITLEB,
     1             Lq,DT,TPRINT,DTPRINT,TMAX,
     2             Xlength,Cmono,EPS_acoust,KEYslope,
     3             MATLI,ULI,ROLI,MATRI,URI,RORI,
     5             KEYSYM,AUTODT,CFL,GODUNOV,
     6             KEYwidth,KEYbedslope,KEYfriction
C***********************************************************************
      PRINT*,'ENTER INIDAT.'
      GG      = 9.81d0 ! Gravity constant [m/s^2]
      GG      =10.00d0 ! Gravity constant [m/s^2]
      A       = GG/2.d0
      Aphalf  = SQRT(A)
      PAI =4.d0*ATAN(1.d0)
      PAI2=2.d0*ATAN(1.d0)
      ETA2=0.00d0**2  !  Manning resistance coefficient squared [s/m^(1/3)]**2
      Problem = 1  !  Sod's problem
      TITLEA='                                                         '
      TITLEB='                                                         '
      TPRINT=0.
      DT=0.001d0
      AUTODT=.true.
      GODUNOV=.FALSE.
      CFL         =  0.50d0 ! Stability coefficient
      Cmono       =  2.00d0 ! Monotonization coefficient (Cmono.LE.2)
      EPS_acoust  =  1.00d-3! Acoustic approximation parameter (see GRP)
      KEYslope    =  'CD '  ! Centered Differencing (Colella et al)
      KEYslope    =  'CID'  ! Cell-Interface Differencing (original GRP)
      Xlength     =  100.d0 ! Initial length of computation interval
      KEYSYM=1
      KEYwidth   =0
      KEYbedslope=0
      KEYfriction=0
      UMIN=0
      UMAX=1000.d0
      ROMIN=0.d0
      ROMAX=1.25d-5
                 DTPRINT=10.d0
                 TMAX   =30.d0
      MATLI   = 1
      ULI     = 0.d0
      ROLI    = 1.3d0
      MATRI   = 1
      URI     = 0.d0
      RORI    = 0.125d0
C***********************************************************************
C  UNITS   kg  m  sec
C***********************************************************************
C  VELOCITY     (m/sec)
C  DENSITY(RO)  (m)
C***********************************************************************
C***********************************************************************
      PRINT*,'READ IN'
      READ(5,IN)
C***********************************************************************

      CLI = SQRT(GG*ROLI)
      CRI = SQRT(GG*RORI)

      Xmin = 0
      Xmax = Xmin + Xlength

      PRINT*,'PRINT IN'
              PRINT IN

C  Check dimension Lq
      IF(Lq.GT.LDIM) THEN
         PRINT*,'INIDAT.  Lq.GT.LDIM.  INCREASE LDIM.'
         PRINT*,'INIDAT.  Lq,LDIM=',Lq,LDIM
         CALL ENDRUN(63)
      ENDIF
      L =Lq
      LL=L -1

C=======================================================================
C***********************************************************************
C  EXACT SOLUTION FOR SAMPLE PROBLEMS (According to value of Problem)
C***********************************************************************
C=======================================================================
      OPEN(99,FORM='FORMATTED',FILE='fort.99',STATUS='UNKNOWN')
      GOTO(1,2,3,4,5,6,7,8,9,10), Problem
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C  Dam Break Problem -- Assuming a right-facing shock (dam high on left)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 1    CONTINUE
      PRINT*,'EXACT SOLUTION   Problem=',Problem
      PRINT*,'ROLI,ULI,RORI,URI=',ROLI,ULI,RORI,URI
      CALL DAM_BREAK(L)
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 2    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 3    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 4    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 5    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 6    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 7    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 8    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 9    CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 10   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 100  CONTINUE
      CLOSE(99)
      PRINT*,'EXACT SOLUTION   Written on fort.99'

      PRINT*,'EXIT INIDAT.'
      RETURN
      END




