      SUBROUTINE RIEMANN(L,I,MAT,UL,ROL,CL,GL,
     1                           UR,ROR,CR,GR,
     2                           USTAR,ROSTAR,CSTAR,GSTAR,
     3                           WLAGL,WLAGR,UW,
     4                           ACOUSTIC,SHOCKL,SHOCKR)
         include 'type.inc'
         include 'miscel.inc'
      INTEGER    L,I,K,MAT,NMAX,NL,NR,N,NCASE
      REAL*8     UL,ROL,CL,GL,UR,ROR,CR,GR
      REAL*8     UW(5),EPS,UMIDA,DU,DUDRO,DUDROL,DUDROR
      REAL*8     USTAR,CSTAR,GSTAR,WLAGL,WLAGR,WLE,WRE,ROSTAR
      REAL*8     RO,UshockL,UshockR,UrarefL,UrarefR
      REAL*8     U,USL,USR,UEL,UER,EPSL,EPSR
      REAL*8     Uprime_shockL,Uprime_shockR,Uprime_rarefL,Uprime_rarefR
      LOGICAL    ACOUSTIC,SHOCKL,SHOCKR
      UshockL(RO) = UL-Aphalf*(RO-ROL)*SQRT(1/RO+1/ROL)
      UshockR(RO) = UR+Aphalf*(RO-ROR)*SQRT(1/RO+1/ROR)
      UrarefL(RO) = UL-SQRT(8*A)*(SQRT(RO)-SQRT(ROL))
      UrarefR(RO) = UR+SQRT(8*A)*(SQRT(RO)-SQRT(ROR))
      Uprime_shockL(RO) = -(Aphalf*SQRT(1/RO+1/ROL))
     1                    +(Aphalf*(RO-ROL))/(2*SQRT(1/RO+1/ROL)*RO**2)
      Uprime_shockR(RO) =  (Aphalf*SQRT(1/RO+1/ROR))
     1                    -(Aphalf*(RO-ROR))/(2*SQRT(1/RO+1/ROR)*RO**2)
      Uprime_rarefL(RO) = -SQRT(2*A/RO)
      Uprime_rarefR(RO) =  SQRT(2*A/RO)
C***********************************************************************
      DATA  NMAX/  77 /
      DATA  EPS/1.d-10/
C***********************************************************************
                        IF(ROR.LE.ROL) THEN
C  RIGHT DENSITY IS LOWER
      USR=UshockR(ROL)
      UEL=UrarefL(ROR)
                     NL=2 ! shock
                     NR=2 ! shock
      IF (USR.GE.UL) NL=1 ! rarefaction
      IF (UEL.LE.UR) NR=1 ! rarefaction
      IF (NL.EQ.2.AND.NR.EQ.1) GO TO 7001
                        ELSE
C  RIGHT DENSITY IS HIGHER
      USL=UL-Aphalf*(ROR-ROL)*SQRT(1.d0/ROR+1.d0/ROL)
      UER=UR+SQRT(8*A)*(SQRT(ROL)-SQRT(ROR))
      USL=UshockL(ROR)
      UER=UrarefR(ROL)
                     NL=2 ! shock
                     NR=2 ! shock
      IF (UER.GE.UL) NL=1 ! rarefaction
      IF (USL.LE.UR) NR=1 ! rarefaction
      IF (NL.EQ.1.AND.NR.EQ.2) GO TO 7001
                        ENDIF

      IF (NL.EQ.1.AND.NR.EQ.2) NCASE=1
      IF (NL.EQ.2.AND.NR.EQ.2) NCASE=2
      IF (NL.EQ.2.AND.NR.EQ.1) NCASE=3
      IF (NL.EQ.1.AND.NR.EQ.1) NCASE=4
      UMIDA=EPS*MAX(CL,CR)
      DUDROL=-(CL/ROL) ! From relation along transverse characteristic
      DUDROR= (CR/ROR) ! From relation along transverse characteristic
      RO=( UL- UR+ROR*DUDROR-ROL*DUDROL)/(  DUDROR-  DUDROL)
      U =(ROL-ROR+ UR/DUDROR- UL/DUDROL)/(1/DUDROR-1/DUDROL)
      N=0
      GO TO (1,2,3,4), NCASE
C  THE CASE  ES
  1   SHOCKL=.FALSE.
      SHOCKR=.TRUE.
 11   N=N+1
      IF (N.GT.NMAX) GO TO 7003
      DU=UrarefL(RO)-UshockR(RO)
      IF (ABS(DU).LE.UMIDA) GO TO 10
      DUDRO=Uprime_rarefL(RO)-Uprime_shockR(RO)
      RO=RO-(DU/DUDRO)
      GO TO 11
 10   CONTINUE
      USTAR=(UrarefL(RO)+UshockR(RO))/2
      ROSTAR=RO
      CSTAR=SQRT(2*A*RO)
      GSTAR=CSTAR*RO
      EPSL = (RO-ROL)/MAX(ROL,ROR)
      EPSR = (RO-ROR)/MAX(ROL,ROR)
      IF(EPSL.GT.+1.d-9.OR.EPSR.LT.-1.d-9) GOTO 7002
      WLAGL = -GL
      WLAGR =  SQRT(A*RO*ROR*(RO+ROR))
      WRE=WLAGR/ROR+UR
      UW(1)=UL-CL
      UW(2)=USTAR-CSTAR
      UW(3)=USTAR
      UW(4)=WRE
      UW(5)=WRE
      GO TO 5
C  THE CASE  SS
 2    SHOCKL=.TRUE.
      SHOCKR=.TRUE.
 21   N=N+1
      IF (N.GT.NMAX) GO TO 7003
      DU=UshockL(RO)-UshockR(RO)
      IF (ABS(DU).LE.UMIDA) GO TO 20
      DUDRO=Uprime_shockL(RO)-Uprime_shockR(RO)
      RO=RO-(DU/DUDRO)
      GO TO 21
 20   CONTINUE
      USTAR=(UshockL(RO)+UshockR(RO))/2
      ROSTAR=RO
      CSTAR=SQRT(2*A*RO)
      GSTAR=CSTAR*RO
      EPSL = (RO-ROL)/MAX(ROL,ROR)
      EPSR = (RO-ROR)/MAX(ROL,ROR)
      IF(EPSL.LT.-1.d-9.OR.EPSR.LT.-1.d-9) GOTO 7002
      WLAGL = -SQRT(A*RO*ROL*(RO+ROL))
      WLAGR =  SQRT(A*RO*ROR*(RO+ROR))
      WLE= (WLAGL/ROL)+UL
      WRE= (WLAGR/ROR)+UR
      UW(1)=WLE
      UW(2)=WLE
      UW(3)=USTAR
      UW(4)=WRE
      UW(5)=WRE
      GO TO 5
C  THE CASE  SE
 3    SHOCKL=.TRUE.
      SHOCKR=.FALSE.
 31   N=N+1
      IF (N.GT.NMAX) GO TO 7003
      DU=UshockL(RO)-UrarefR(RO)
      IF (ABS(DU).LE.UMIDA) GO TO 30
      DUDRO=Uprime_shockL(RO)-Uprime_rarefR(RO)
      RO=RO-(DU/DUDRO)
      GO TO 31
 30   CONTINUE
      USTAR=(UshockL(RO)+UrarefR(RO))/2
      ROSTAR=RO
      CSTAR=SQRT(2*A*RO)
      GSTAR=CSTAR*RO
      EPSL = (RO-ROL)/MAX(ROL,ROR)
      EPSR = (RO-ROR)/MAX(ROL,ROR)
      IF(EPSL.LT.-1.d-9.OR.EPSR.GT.+1.d-9) GOTO 7002
      WLAGL = -SQRT(A*RO*ROL*(RO+ROL))
      WLAGR =  GR
      WLE   = (WLAGL/ROL)+UL
      UW(1)=WLE
      UW(2)=WLE
      UW(3)=USTAR
      UW(4)=USTAR+CSTAR
      UW(5)=UR+CR
      GO TO 5
C  THE CASE  EE
 4    SHOCKL=.FALSE.
      SHOCKR=.FALSE.
C  This case has an explicit solution
      RO = ((UL-UR)/SQRT(32*A)+(SQRT(ROL)+SQRT(ROR))/2)**2
      U  = UrarefL(RO)
      USTAR=U
      ROSTAR=RO
      CSTAR=SQRT(2*A*RO)
      GSTAR=CSTAR*RO
      EPSL = (RO-ROL)/MAX(ROL,ROR)
      EPSR = (RO-ROR)/MAX(ROL,ROR)
      IF(EPSL.GT.+1.d-9.OR.EPSR.GT.+1.d-9) GOTO 7002
      WLAGL = -GL
      WLAGR =  GR
      UW(1)=UL-CL
      UW(2)=USTAR-CSTAR
      UW(3)=USTAR
      UW(4)=USTAR+CSTAR
      UW(5)=UR+CR
      N=1
      GO TO 5
 5    CONTINUE

      RETURN
C***********************************************************************
C************* ERROR MESSAGES ******************************************
C***********************************************************************
 7001 CONTINUE
      PRINT 7101,ROL,UL,ROR,UR,USL,USR,UEL,UER,NL,NR,I
 7101 FORMAT(/'RP_SOLVE.  AN IMPOSSIBLE CASE OF EXPANSION/SHOCK'/
     1        'ROL,UL,ROR,UR=',1P,4E12.4/
     2        'USL,USR,UEL,UER=',1P,4E12.4/
     3        'NL,NR,I=',3I10//)
      CALL ENDRUN(7001)
 7002 CONTINUE
      PRINT 7102,I,NL,NR,NCASE,ROL,UL,ROR,UR,ROSTAR,USTAR,
     1           ROL-ROSTAR,ROR-ROSTAR,EPSL,EPSR,ACOUSTIC,SHOCKL,SHOCKR
 7102 FORMAT(/'AN INCONSISTENT SOLUTION TO RIEMANN PROBLEM.'/
     1        'STAR VALUES INCONSISTENT WITH L/R VALUES AND WAVE TYPE'/
     2        'I,NL,NR,NCASE         =',4I6/
     3        'ROL,UL,ROR,UR         =',1P,4E18.9/
     4        'ROSTAR,USTAR          =',2E18.9/
     5        'ROL-ROSTAR,ROR-ROSTAR =',2E12.4/
     5        'EPSL,EPSR             =',2E12.4/
     6        'ACOUSTIC,SHOCKL,SHOCKR=',3L6//)
      CALL ENDRUN(7002)
 7003 CONTINUE
      PRINT 7103,I,N,NCASE,DU,UMIDA,EPS,ROL,UL,ROR,UR,U,RO,DUDRO
 7103 FORMAT(/'RP_SOLVE.  NUMBER OF ITERATIONS EXCEEDED.'/
     1        'I,N,NCASE,DU,UMIDA,EPS=',3I6,3E18.6/
     2        'ROL,UL,ROR,UR=',4E18.6/
     3        'U,RO,DUDRO=',3E18.6//)
      CALL ENDRUN(7003)
      END                                                               




