      PROGRAM SW_1D ! Shallow Water GRP
                include  'type.inc'
                include  'dimen.inc'
                include  'vecs.inc'
                include  'draw.inc'
                include  'init.inc'
                include  'miscel.inc'

      INTEGER L,NPRINT,K
C***********************************************************************
      COMMON/EXACT/ROexact(LDIM),Uexact(LDIM)
      REAL*8       ROexact      ,Uexact
      REAL*8 upRO,dnRO,upU , dnU
C***********************************************************************
 

C***********************************************************************
      VERSION = 'GRP/SW-1D.05'
      OPEN(UNIT=5,FILE='input.nam',FORM='FORMATTED',STATUS='OLD')
C***********************************************************************
C***********************************************************************
C   **********   GENERAL DATA   *************
C***********************************************************************
      CALL INIDAT(L)
      L=Lq
      PRINT 111,VERSION,L
 111  FORMAT(/72('*')/A12,4X,'L = ',I6/72('*')/)
      LL=L-1
      DELT=DT
C***********************************************************************
C   **********   INITIAL CONDITIONS   *************
C***********************************************************************
      CALL BEGIN(L)
C***********************************************************************
C  ********   BEGIN LOOP ON CYCLES   *************
C***********************************************************************
      CFLMAX=0
      CFLMIN=1.d99
      NCYCMX=0
      NCYCMN=0
      T=0
      NCYC=0
      DT=0
      DTBACK=0
 1    NCYC=NCYC+1
C***********************************************************************
C  ********   TIME-STEP EVALUATION   ***********
C***********************************************************************
      IF(NCYC.LE.1) GOTO 2
      IF(AUTODT) THEN
        DT = DTNEXT*CFL
        IF (DT.GT.1.05d0*DTBACK.AND.DTBACK.NE.0.d0) DT = 1.05d0*DTBACK
      ELSE
        DT = DELT
      ENDIF
      IF(NCYC.EQ.2) DT = DT/1.d0
      NPRINT = ((MIN(TPRINT,TMAX)-T)/DT-1.d-10)
      IF (NPRINT.LT.10) DT = (MIN(TPRINT,TMAX)-T)/FLOAT(NPRINT+1)

      CFLMXC=0
      DO 11 K=2,LL
      CFLM=DT/DTNEXT_C(K)
      IF(CFLM.GT.CFLMXC) CFLMXC = CFLM
 11   CONTINUE
      IF(CFLMXC.GT.CFLMAX) THEN
        CFLMAX = CFLMXC
        NCYCMX = NCYC
      ENDIF
      IF(CFLMXC.LT.CFLMIN) THEN
        CFLMIN = CFLMXC
        NCYCMN = NCYC
      ENDIF
 2    CONTINUE

      DT2    = DT/2
      DTBACK = DT
C***********************************************************************
C  ********   INTEGRATION BY ONE TIME-STEP   T(N) ---> T(N+1)    *******
C***********************************************************************
      T=T+DT
      IF(MOD(NCYC,1).EQ.0)  PRINT 10, NCYC,T,DT,CFLMXC,KDT
 10   FORMAT('NCYC=',I6,2X,'T=',G11.4,1X,'DT=',G11.4,4X,
     1       'CFL=',G10.3,2X,'KDT=',I5)
      IF(MOD(NCYC,1).EQ.0)  PRINT 20, AMTOT,ROUTOT
 20   FORMAT(13X,'AMTOT,ROUTOT=',G15.7,3X,G15.7)
                                            NERI=1
      IF(ABS(T-TPRINT).LE.1.d-3*DT        ) NERI=0
      IF(    NCYC     .EQ.1               ) NERI=0
      IF(ABS(T-TMAX).LE.1.d-3*DT.OR . T.GT.TMAX) NERI=0
C***********************************************************************
C***********************************************************************
      CALL CYCLE(L) !  T(N) ==> T(N+1)
C***********************************************************************
C***********************************************************************

C***********************************************************************
C  ********   O U T P U T   (PRINT, DRAW, CONTINUATION FILE)   *********
C***********************************************************************
      CALL HISTORY(L)

      IF (NERI.NE.0) GO TO 3
        CALL PRINT(L)
         IF(ABS(T-TPRINT).LT.1.d-8) TPRINT=TPRINT+DTPRINT
         PRINT*,'SW-1D.  NEXT PRINTING AT  TPRINT=',TPRINT
 3    CONTINUE
C***********************************************************************
      IF (T.LT.TMAX-1.d-6) GO TO 1
      PRINT 777,TMAX,CFLMAX
 777  FORMAT(/'END OF RUN AT   TMAX = ',G13.5,5X,'CFLMAX = ',G13.5/)
      GOTO(51,52,53,54,55,56,57,58,59), Problem
 51    CONTINUE
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C  Dam Break Problem -- Assuming a right-facing shock (dam high on left)
C  Compute the error of the computation by checking it against the 
C  exact solution.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!     PRINT*,'EXACT SOLUTION   Problem=',Problem
!     PRINT*,'ROLI,ULI,RORI,URI=',ROLI,ULI,RORI,URI
      upRO=0.0d0
      dnRO=0.0d0
      upU =0.0d0
      dnU =0.0d0

      DO K=2,LL
        upRO=upRO + abs(RO(K)-ROexact(K))
        upU =upU  + abs( U(K)- Uexact(K))
        dnRO=dnRO + abs(      ROexact(K))
        dnU =dnU  + abs(       Uexact(K))
      END DO
                        ErrRO=0.d0
      IF(dnRO.gt.0.d0)  ErrRO=upRO/dnRO
                        ErrU =0.d0
      IF( dnU.gt.0.d0)  ErrU =upU /dnU 
      PRINT 778,ErrRO,ErrU 
 778  FORMAT(/'  ErrRO = ',G13.5,5X,'ErrU = ',G13.5/)
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 52   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 53   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 54   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 55   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 56   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 57   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 58   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 59   CONTINUE
      GOTO 100
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 100  CONTINUE

      CALL SET_TITLE(L)
      GOTO 7777
C***********************************************************************
C************* ERROR MESSAGES ******************************************
C***********************************************************************
 7001 CONTINUE
      CALL ENDRUN(7001)
 7777 CONTINUE
      END




      SUBROUTINE ENDRUN(Istop)

                include  'type.inc'
                include  'dimen.inc'
                include  'miscel.inc'
      INTEGER  Istop
C***********************************************************************
      PRINT 1, Istop,NCYC
 1    FORMAT(/'ENDRUN DUE TO ERROR.   Istop,NCYC=',2I7/)
      CALL SET_TITLE(Lq)
      STOP
      END




